<template>
  <div class="q-pa-md q-gutter-sm">
    <q-dialog v-model="toolbar">
      <q-card>
        <q-toolbar>
          <!--  <q-avatar>
            <img src="https://cdn.quasar.dev/logo-v2/svg/logo.svg" />
          </q-avatar>

          <q-toolbar-title
            ><span class="text-weight-bold">Quasar</span>
            Framework</q-toolbar-title
          >
-->
          <q-space />
          <q-btn color="purple" round dense icon="close" v-close-popup />
        </q-toolbar>

        <q-card-section>
          <AddUser />
        </q-card-section>
      </q-card>
    </q-dialog>
  </div>

  <q-dialog v-model="confirm" persistent>
    <q-card>
      <q-card-section class="row items-center">
        <q-avatar icon="priority_high" color="red" text-color="white" />
        <span class="q-ml-sm"
          >Esta seguro de eliminar el id: {{ idelim }} ?</span
        >
      </q-card-section>

      <q-card-actions align="right">
        <q-btn flat label="Cancelar" color="red" v-close-popup />
        <q-btn
          flat
          label="Confirmar"
          color="primary"
          @click="eliminar(idelim)"
          v-close-popup
        />
      </q-card-actions>
    </q-card>
  </q-dialog>

  <!--  <pre>{{ data }}</pre> -->
  <div class="q-pa-md">
    <q-btn
      class="q-mb-md"
      round
      color="purple"
      icon="add"
      @click="toolbar = true"
    />

    <q-table
      title="Lista Usuarios"
      :rows="rows"
      :columns="columns"
      row-key="id"
      :filter="filter"
      binary-state-sort
    >
      <template v-slot:top>
        <div class="col-2 q-table__title">Usuarios</div>
        <q-space />
        <q-input
          borderless
          dense
          debounce="300"
          v-model="filter"
          placeholder="Search"
        >
          <template v-slot:append>
            <q-icon name="search" />
          </template>
        </q-input>
      </template>

      <template v-slot:header="props">
        <q-tr :props="props">
          <q-th auto-width />
          <q-th v-for="col in props.cols" :key="col.name" :props="props">
            {{ col.label }}
          </q-th>
        </q-tr>
      </template>
      <template v-slot:body="props">
        <q-tr :props="props">
          <q-td auto-width>
            <q-btn
              size="sm"
              round
              color="red"
              glossy
              @click="(confirm = !confirm), (idelim = props.key)"
              icon="delete"
          /></q-td>
          <q-td key="id" :props="props">
            {{ props.row.id }}
            <!--      <q-popup-edit v-model="props.row.id" v-slot="scope">
              <q-input v-model="scope.value" dense autofocus counter />
            </q-popup-edit> -->
          </q-td>
          <q-td key="user" :props="props">
            {{ props.row.user }}
            <q-popup-edit
              v-model="props.row.user"
              v-slot="scope"
              title="Actualizar User"
              buttons
              label-set="Guardar"
              label-cancel="Cancelar"
              @save="
                (v, iv) => {
                  save(v, iv, props.key, 'usuario');
                }
              "
            >
              <q-input type="text" v-model="scope.value" dense autofocus />
            </q-popup-edit>
          </q-td>
          <q-td key="name_lastName" :props="props">
            <div class="text-pre-wrap">{{ props.row.name_lastName }}</div>
            <q-popup-edit
              v-model="props.row.name_lastName"
              v-slot="scope"
              title="Actualiza Nombre"
              buttons
              label-set="Guardar"
              label-cancel="Cancelar"
              @save="
                (v, iv) => {
                  save(v, iv, props.key, 'nombre_y_apellido');
                }
              "
            >
              <q-input type="text" v-model="scope.value" dense autofocus />
            </q-popup-edit>
          </q-td>

          <q-td key="mail" :props="props">
            {{ props.row.mail }}
            <q-popup-edit
              v-model="props.row.mail"
              title="Email"
              buttons
              persistent
              v-slot="scope"
              label-set="Guardar"
              label-cancel="Cancelar"
              @save="
                (v, iv) => {
                  save(v, iv, props.key, 'correo_electronico');
                }
              "
            >
              <q-input
                type="text"
                v-model="scope.value"
                dense
                autofocus
                hint="Debe ingresar un mail"
              />
            </q-popup-edit>
          </q-td>
          <!--  -->
          <q-td key="telephone" :props="props"
            >{{ props.row.telephone }}
            <q-popup-edit
              v-model="props.row.telephone"
              title="Celular"
              buttons
              persistent
              v-slot="scope"
              label-set="Guardar"
              label-cancel="Cancelar"
              @save="
                (v, iv) => {
                  save(v, iv, props.key, 'telefono');
                }
              "
            >
              <q-input
                type="number"
                v-model="scope.value"
                dense
                autofocus
                hint="Debe ingresar un nro celular"
              />
            </q-popup-edit>
          </q-td>
          <q-td key="shipping_address" :props="props"
            >{{ props.row.shipping_address }}
            <q-popup-edit
              v-model="props.row.shipping_address"
              title="Direccion de compra"
              buttons
              persistent
              v-slot="scope"
              label-set="Guardar"
              label-cancel="Cancelar"
              @save="
                (v, iv) => {
                  save(v, iv, props.key, 'direccion_de_envio');
                }
              "
            >
              <q-input
                type="text"
                v-model="scope.value"
                dense
                autofocus
                hint="Debe ingresar una direccion "
              />
            </q-popup-edit>
          </q-td>
          <q-td key="password" :props="props"
            >{{ props.row.password }}
            <q-popup-edit
              v-model="props.row.password"
              title="Contraseña"
              buttons
              persistent
              v-slot="scope"
              label-set="Guardar"
              label-cancel="Cancelar"
              @save="
                (v, iv) => {
                  save(v, iv, props.key, 'contrasena');
                }
              "
            >
              <q-input
                type="password"
                v-model="scope.value"
                dense
                autofocus
                hint="Contraseña "
              />
            </q-popup-edit>
          </q-td>
          <q-td key="profile" :props="props"
            >{{ props.row.profile }}
            <q-popup-edit
              v-model="props.row.profile"
              title="Perfil"
              buttons
              persistent
              v-slot="scope"
              label-set="Guardar"
              label-cancel="Cancelar"
              @save="
                (v, iv) => {
                  save(v, iv, props.key, 'perfil');
                }
              "
            >
              <q-input
                type="text"
                v-model="scope.value"
                dense
                autofocus
                hint="Perfil "
              />
            </q-popup-edit>
          </q-td>
          <q-td key="discontinued" :props="props"
            >{{ props.row.discontinued }}
            <q-popup-edit
              v-model="props.row.discontinued"
              title="Habilitado"
              buttons
              persistent
              v-slot="scope"
              label-set="Guardar"
              label-cancel="Cancelar"
              @save="
                (v, iv) => {
                  save(v, iv, props.key, 'suspender');
                }
              "
            >
              <q-input
                type="bool"
                v-model="scope.value"
                dense
                autofocus
                hint="Perfil "
              />
            </q-popup-edit>
          </q-td>
        </q-tr>
      </template>
    </q-table>
  </div>
</template>

<script>
import { api } from "boot/axios";
import { ref, onMounted } from "vue";
import { useQuasar, SessionStorage } from "quasar";
import AddUser from "src/components/user/AddUser.vue";

const columns = [
  {
    name: "id",
    required: true,
    label: "Id Users",
    align: "left",
    field: (row) => row.name,
    format: (val) => `${val}`,
    sortable: true,
  },
  {
    name: "user",
    align: "center",
    label: "Usuarios",
    field: "user",
    sortable: true,
  },
  {
    name: "name_lastName",
    label: "Nombre Usuario",
    field: "name_lastName",
    sortable: true,
    style: "width: 10px",
  },
  { name: "mail", label: "Email", field: "mail" },
  { name: "telephone", label: "Telefono", field: "telephone" },
  {
    name: "shipping_address",
    label: "Direccion Compra",
    field: "shipping_address",
  },
  {
    name: "password",
    label: "password",
    field: "password",
    sortable: true,
    sort: (a, b) => parseInt(a, 10) - parseInt(b, 10),
  },
  {
    name: "profile",
    label: "Perfil",
    field: "profile",
    sortable: true,
    sort: (a, b) => parseInt(a, 10) - parseInt(b, 10),
  },
  {
    name: "discontinued",
    label: "Discontinued",
    field: "discontinued",
    sortable: true,
    sort: (a, b) => parseInt(a, 10) - parseInt(b, 10),
  },
];

export default {
  setup() {
    const $q = useQuasar();
    const token = SessionStorage.getItem("jwt");
    const data = ref([]);
    function returnUsers() {
      api
        .get("usuarios", {
          headers: {
            accept: "application/json",
            Authorization: token,
          },
        })
        .then((response) => {
          /* console.log("datos " + JSON.stringify(response.data.data)); */
          data.value = response.data.data;
          //    return JSON.stringify(response.data.data);
        })
        .catch((error) => {
          $q.notify({
            color: "negative",
            position: "bottom",
            message: `code: ${error.response.status} - Mensaje ${error}`,
            icon: "report_problem",
          });
          /* } */
          console.log(error);
        });
    }
    onMounted(() => {
      returnUsers();
    });
    return {
      filter: ref(""),
      save(value, initialValue, id, field) {
        const user = `{ "${field}": "${value}"  }`;
        api
          .put(`usuarios/${id}`, JSON.parse(user), {
            headers: {
              accept: "application/json",
              Authorization: token,
            },
          })
          .then((response) => {
            console.log(`user actualizado `);
            $q.notify({
              color: "positive",
              position: "bottom",
              message: `Se guardo el campo: ${field} con el nuevo valor ${value} correctamente`,
              icon: "mood",
            });
          })
          .catch((error) => {
            console.log(`user no actualizado ${error}`);
            $q.notify({
              color: "negative",
              position: "bottom",
              message: `Mensaje ${error}`,
              icon: "report_problem",
            });
          });
      },
      eliminar(id) {
        console.log(`url usuarios/${id}`);
        api
          .delete(`usuarios/${id}`, {
            headers: {
              accept: "application/json",
              Authorization: token,
            },
          })
          .then((response) => {
            console.log(`Registro eliminado`);
            $q.notify({
              color: "positive",
              position: "bottom",
              message: `Se elimino el usuario id: ${this.idelim.value} correctamente`,
              icon: "mood",
            });
            returnUsers();
          })
          .catch((error) => {
            $q.notify({
              color: "negative",
              position: "bottom",
              message: `Mensaje ${error}`,
              icon: "report_problem",
            });
          });
      },
      columns,
      rows: ref(data),
      data,
      confirm: ref(false),
      toolbar: ref(false),
      idelim: ref(0),
    };
  },
  components: { AddUser },
};
</script>
